# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "zskeleton4xi.py">
#<abstract4xi abstract = "offers functions and classes starting with z/Z"/>
#<refer4xi reference = "Skeleton"/>
#<verify4xi verification = "10" target = "test_zskeleton4xi.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ZSkeleton4Xi',
            'init_zskeleton4xi',
            'set_zskeleton4xi',
            'get_zskeleton4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
# None
#"
#/>
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "init-zskeleton4xi" usage = "initializes zskeleton4xi objects"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def init_zskeleton4xi(z_init_param1 = None): 
    '''
    initializes zskeleton4xi objects
    '''

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "init_zskeleton4xi"
    method2print = "init_zskeleton4xi"

    message2print = "{(Step 1/3a) started" + "; init-zskeleton4xi-started: " + str(init_zskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
  
                
    message2print = "{(Step 1/3b) passed" + "; z-init-param1-passed-to-init-zskeleton4xi: " + str(z_init_param1) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    z2xi = z_init_param1            
    
    message2print = "{(Step 2/3) initialized" + "; z2xi-initialized-by-init-zskeleton4xi to: " + str(z2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
        

    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 3/3) returning" + "; init-zskeleton4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set-zskeleton4xi" usage = "
# setializes zskeleton4xi objects
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def set_zskeleton4xi(z_set_param1 = None): 
    '''
    set_zskeleton4xi sets zskeleton4xi objects
    '''

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "set_zskeleton4xi"
    method2print = "set_zskeleton4xi"

    message2print = "{(Step 1/3a) started" + "; set-zskeleton4xi-started: " + str(set_zskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/3b) passed" + "; z-set-param1-passed-to-set-zskeleton4xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    z2xi = z_set_param1            
    
    message2print = "{(Step 2/3) initialized" + "; z2xi-initialized-by-set-zskeleton4xi to: " + str(z2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
        

    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 3/3) returning" + "; set-zskeleton4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get-zskeleton4xi" usage = "
#   gets zskeleton4xi objects
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------   
def get_zskeleton4xi(): 
    '''
    get_zskeleton4xi gets zskeleton4xi objects
    '''

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get_zskeleton4xi"
    method2print = "get_zskeleton4xi"

    message2print = "{(Step 1/3) started" + "; get-zskeleton4xi-started: " + str(get_zskeleton4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        

    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    
    z2xi = "z2xi"
        
    message2print = "{(Step 2/3) got" + "; z2xi-got-by-get-zskeleton4xi: " + str(z2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
                
    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    
    message2print = "{returning" + "; z2xi-returning-by-get-zskeleton4xi: " + str(z2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
                            
    
    return z2xi     
        
#</function4xi>
 
                                               
# =================================================================================================
#<class4xi class = "ZSkeleton4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for zskeleton4xi module" usage = "skeleton for u*4xi.py"
#>
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# =================================================================================================
class ZSkeleton4Xi(object): 
    ''' 
    ZSkeleton4Xi offers  methods for zskeleton4xi module
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2z = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'init_zskeleton',
    'set_zskeleton',
    'get_zskeleton',    
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-ZSkeleton4Xi" usage = "initializes ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, z_init_param1 = None):
        '''
        _init__ method initializes ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "ZSkeleton4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1/3a) started" + "; init-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{(Step 1/3b) borning" + "; zskeleton2xi-of-ZSkeleton4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        message2print = "{(Step 1/3c) inheriting" + "; object-inheriting-by-zskeleton2xi-of-ZSkeleton4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{(Step 1/3d) sharing" + "; classvariable2z-sharing-by-zskeleton2xi-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi.classvariable2z)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                                
        message2print = "{(Step 1/3e) passed" + "; z-init-param1-passed-to-init-of-ZSkeleton4Xi: " + str(z_init_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                          
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2/3a) passing" + "; z-init-param1-passing-to-init-zskeleton4xi-by-init-of-ZSkeleton4Xi: " + str(z_init_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        init_zskeleton4xi(z_init_param1)
        
        message2print = "{(Step 2/3b) performed" + "; init-zskeleton4xi-performed-by-init-of-ZSkeleton4Xi: " + str(init_zskeleton4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3/3a) activated" + "; zskeleton2xi-of-ZSkeleton4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        message2print = "{(Step 3/3b) inherited" + "; object-inherited-by-zskeleton2xi-of-ZSkeleton4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{(Step 3/3c) shared" + "; classvariable2z-shared-by-zskeleton2xi-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi.classvariable2z)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
       
        message2print = "{(Step 3/3x) returning" + "; init-zskeleton-of-ZSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-zskeleton-of-ZSkeleton4Xi" usage = "initializes objects of ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def init_zskeleton(self, z_init_param1 = None):
        '''
        init_zskeleton method initializes objects of ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "ZSkeleton4Xi"
        method2print = "init_zskeleton"
                     
        message2print = "{(Step 1/3a) started" + "; init-zskeleton-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1/3b) passed" + "; z-init-param1-passed-to-init-zskeleton-of-ZSkeleton4Xi: " + str(z_init_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3a) passing" + "; z-init-param1-passing-to-init-zskeleton4xi-by-init-zskeleton-of-ZSkeleton4Xi: " + str(z_init_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        init_zskeleton4xi(z_init_param1)

        message2print = "{(Step 2/3b) performed" + "; init-zskeleton4xi-performed-by-init-zskeleton-of-ZSkeleton4Xi: " + str(init_zskeleton4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; init-zskeleton-of-ZSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                
                            
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-zskeleton-of-ZSkeleton4Xi" usage = "sets objects of ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def set_zskeleton(self, z_set_param1 = None):
        '''
        set_zskeleton method sets objects of ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "ZSkeleton4Xi"
        method2print = "set_zskeleton"
                     
        message2print = "{(Step 1/3a) started" + "; set-zskeleton-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1/3b) passed" + "; z-set-param1-passed-to-set-zskeleton-of-ZSkeleton4Xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3a) passing" + "; z-set-param1-passing-to-set-zskeleton4xi-by-set-zskeleton-of-ZSkeleton4Xi: " + str(z_set_param1) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        set_zskeleton4xi(z_set_param1)

        message2print = "{(Step 2/3b) performed" + "; set-zskeleton4xi-performed-by-set-zskeleton-of-ZSkeleton4Xi: " + str(set_zskeleton4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/3c) returning" + "; set-zskeleton-of-ZSkeleton4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-zskeleton-of-ZSkeleton4Xi" usage = "gets objects of ZSkeleton4Xi">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------   
    def get_zskeleton(self):
        '''
        get_zskeleton method gets objects of ZSkeleton4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)           
        # -----------------------------------------------------------------------------------------              
        class2print = "ZSkeleton4Xi"
        method2print = "get_zskeleton"
                     
        message2print = "{(Step 1/2) started" + "; get-zskeleton-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/2)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/2) returning" + "; get-zskeleton4xi-function-returning-by-get-zskeleton-of-ZSkeleton4Xi: " + str(get_zskeleton4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                
        return get_zskeleton4xi()
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ZSkeleton4Xi" usage = "senses ZSkeleton4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses ZSkeleton4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'ZSkeleton4Xi'
        method2print = 'sense'
        
                     
        message2print = "{started" + "; sense-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # {started; sense-of-ZSkeleton4Xi-started: 18:58:34 11/11/10 Pacific Standard Time}
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{sensing" + "; ZSkeleton4Xi-sensing-by-sense-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ZSkeleton4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2z-of-ZSkeleton4Xi'] = ZSkeleton4Xi.classvariable2z
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ZSkeleton4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{sensed" + "; ZSkeleton4Xi-sensed-by-sense-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ZSkeleton4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ZSkeleton4Xi" usage = "reasons ZSkeleton4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons ZSkeleton4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'ZSkeleton4Xi'
        method2print = 'reason'

                     
        message2print = "{started" + "; reason-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{reasoning" + "; ZSkeleton4Xi-reasoning-by-reason-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ZSkeleton4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-ZSkeleton4Xi'] = time4xi() #adding time
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-ZSkeleton4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{reasoned" + "; ZSkeleton4Xi-reasoned-by-reason-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ZSkeleton4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ZSkeleton4Xi" usage = "aces ZSkeleton4Xi class objects">
    #<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces ZSkeleton4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'ZSkeleton4Xi'
        method2print = 'ace'
        
                     
        message2print = "{started" + "; ace-of-ZSkeleton4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{acing" + "; ZSkeleton4Xi-acing-by-ace-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ZSkeleton4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-ZSkeleton4Xi'] = time4xi()
        except:
             message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-ZSkeleton4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{aced" + "; ZSkeleton4Xi-aced-by-ace-of-ZSkeleton4Xi: " + str(ZSkeleton4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ZSkeleton4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_zskeleton4xi.txt
#   sense-test-zskeleton4xi.xml
#   reason-test-zskeleton4xi.xml
#   ace-test-zskeleton4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of zskeleton4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
